﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ganme1
{
    /// <summary>
    /// 小球
    /// </summary>
    public class Bolus
    {
        #region Fildes AND Constructor

        private string shape; //形状保存的字符串
        private Point previousPoint; //保存上一次球的初始位置
        private Point point;  //坐标位置
        private Direction direction; //方向，水平方向，垂直方向
        private int maxcount;  //最大的小球数量
        private int maxIndex; //图案最底部的索引位置
        private int count = 0; //统计削去方块的数量


        public int Maxcount
        {
            get { return maxcount; }
            set { maxcount = value; }
        }

        public int Count1
        {
            get { return count; }
            set { count = value; }
        }

        public int MaxIndex
        {
            get { return maxIndex; }
            set { maxIndex = value; }
        }

        public int Count
        {
            get { return count; }
            set { count = value; }
        }

        public Point PreviousPoint
        {
            get { return previousPoint; }
            set { previousPoint = value; }
        }

        public Direction Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        public Point Point
        {
            get { return point; }
            set { point = value; }
        }

        public string Shape
        {
            get { return shape; }
            set { shape = value; }
        }

        public Bolus()
        {
            direction = new Direction();
            shape = "●";
            maxIndex = 4;
        }

        #endregion

        #region Methords

        /// <summary>
        /// 清除小球走过的路经 
        /// </summary>
        public virtual void Clear()
        {
            Clear(point.X, point.Y);
        }

        public void Clear(int x, int y)
        {
            Console.SetCursorPosition(From.Left + 2 + 2 * x,From.Top + 1 + y);
            Console.Write("  ");
            From.Map[x, y] = 0;
        }

        /// <summary>
        /// 对左进行碰撞操作参数代表是否改变前一个初始位置
        /// </summary>
        private void LeftState(bool type)
        {
            direction.LevelState = 1;
            if (previousPoint.Y > point.Y)
                direction.VerticalState = -1;
            else
                direction.VerticalState = 1;

            point.X = point.X < 0 ? 0 : point.X;

            if (type)
                previousPoint = point;
        }

        /// <summary>
        /// 对右碰撞进行操作
        /// </summary>
        private void RightState(bool type)
        {
            direction.LevelState = -1;
            if (previousPoint.Y > point.Y)
                direction.VerticalState = -1;
            else
                direction.VerticalState = 1;

            point.X = point.X > From.Width - 1 ? From.Width - 1 : point.X;
            if (type)
                previousPoint = point;
        }
        /// <summary>
        /// 对顶部碰撞进行操作
        /// </summary>
        private void TopState(bool type)
        {
            direction.VerticalState = 1;
            if (previousPoint.X > point.X)
                direction.LevelState = -1;
            else
                direction.LevelState = 1;
            point.Y = point.Y < 0 ? 0 : point.Y;
            
            if (type)
                previousPoint = point;
        }

        /// <summary>
        /// 对底部进行碰撞操作
        /// </summary>
        private void BottomState(bool type)
        {
            direction.VerticalState = -1;
            if (previousPoint.X > point.X)
                direction.LevelState = -1;
            else
                direction.LevelState = 1;
            point.Y = point.Y > From.Height - 1 ? From.Height - 1 : point.Y;

            if (type)
                previousPoint = point;
        }

        /// <summary>
        /// 小球碰撞检测True代表没有碰撞了边框或方块
        /// </summary>
        public bool Collision()
        {
            bool state = true;
            int x = point.X + direction.LevelState;
            int y = point.Y + direction.VerticalState;

            x = x < 0 ? 0 : x;
            x = x > From.Width - 1 ? From.Width - 1 : x;

            y = y < 0 ? 0 : y;
            y = y > From.Height - 1 ? From.Height - 1 : y;

            //对左边框进行碰撞分析
            if (point.X <= -1)
            {
                LeftState(true);
            }

            //对右边框进行碰撞分析
            if (point.X == From.Width)
            {
                RightState(true);
            }

            //对顶部进行碰撞分析
            if (point.Y == - 1)
            {
                TopState(true);
            }

            //对底部进行碰撞分析
            if (point.Y == From.Height)
            {
                BottomState(true);
                state = false;
            }

            //对方快进行碰撞分析
            if (From.Map[x, y] == 2 || From.Map[x, y] == 3)
            {
                if (From.Map[x, y] == 2)
                { 
                    Clear(x, y);
                    count++;
                    Game.Count1++;
                    Game.StatisticsWinners();
                }

                if (previousPoint.X > point.X)
                {
                    LeftState(false);
                }
                else
                {
                    RightState(false);
                }

                if (previousPoint.Y > point.Y)
                {
                    TopState(true);
                }
                else
                {
                    BottomState(true);
                }
                
            }

            return state;
        }

        /// <summary>
        /// 移动小球
        /// </summary>
        public bool Move()
        {
           // ClearPath();
            if (!Collision())
                return false;

            int x = point.X + direction.LevelState;
            int y = point.Y + direction.VerticalState;
            Clear();

            //if (Collision())
            //{
                point.X = x;
                point.Y = y;
           // }

            if (point.X >= 0 && point.X < From.Width && point.Y >= 0 && point.Y < From.Height)
            {
                From.Map[point.X, point.Y] = 1;
                Console.SetCursorPosition(From.Left + 2 + 2 * x, From.Top + 1 + y);
                Console.Write(shape);
            }
            return true;
        }

        /// <summary>
        /// 清除小球
        /// </summary>
        public void ClearPath()
        {
            for (int i = maxIndex + 1; i < From.Height - 1; i++)
            {
                for (int j = 0; j < From.Width; j++)
                {
                    Console.SetCursorPosition(From.Left + 2 + 2 * j, From.Top + 1 + i);
                    Console.Write("  ");
                }
            }
        }

        #endregion
    }
}
