﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;

namespace ganme1
{
    /// <summary>
    /// 运行游戏
    /// </summary>
    public class Game
    {
        #region Fildes

        private Timer timer;  //定时器   
        private static Bolus ball = new Bolus(); //小球
        private static bool isMortality = false; //判断是否死亡
        private Bottom bottom; //球拍
        private static int life = 3;//你有几条命，默认是3，你可以自己调大
        private static int maxcount;   //游戏中最大砖块数量
        private static int pass = 0;//当前第几个关口 ， 默认从第一个关口开始
        private static int interval = 50; //小球移动的速度
        private static bool isWin = false; //判断是否赢了
        public static int Fraction = 0;
        private static int Count = 0; //记录碰撞方块的数量
        public static int PreviousFraction = 0;//记录前一个分数

        public static int Life
        {
            get { return Game.life; }
            set { Game.life = value; }
        }

        public static int Count1
        {
            get { return Game.Count; }
            set 
            {
                Game.Count = value;
                DrawPassInfor();
            }
        }

        public static int Interval
        {
            get { return Game.interval; }
            set { Game.interval = value; }
        }

        public static int Pass
        {
            get { return Game.pass; }
            set { Game.pass = value; }
        }

        public static bool IsWin
        {
            get { return isWin; }
            set { isWin = value; }
        }

        public static bool IsMortality1
        {
            get { return Game.isMortality; }
            set { Game.isMortality = value; }
        }

        public static int Maxcount
        {
            get { return maxcount; }
            set { maxcount = value; }
        }

        public static Bolus Ball
        {
            get { return Game.ball; }
            set { Game.ball = value; }
        }

        #endregion

        /// <summary>
        /// 初始化游戏
        /// </summary>
        public Game()
        {
            Start();
            bottom = new Bottom();
         
            //绘制球拍
            bottom.Draw();
            
            //打印关口信息
            DrawPassInfor();

            Run();

            if (!isWin)
            {
                Console.Clear();
                Console.SetCursorPosition(From.Left + 50, From.Top + 10);
                Console.WriteLine("Game over!!!!");
                System.Threading.Thread.Sleep(1000);
                Console.Clear();
            }
            else
            {
                int pass1 = ++pass;
                if (pass > CommonPass.maxpass - 1)
                {
                    Console.Clear();
                    Console.SetCursorPosition(From.Left + 40, From.Top + 10);
                    Console.Write("恭喜你，你成功了");
                    System.Threading.Thread.Sleep(2000);
                    return;
                }
                else
                {
                    Console.Clear();
                    Game.isMortality = false;
                    Game.Count = 0;
                    Game.life = 3;
                    Game.isWin = false;
                    Game.PreviousFraction = Fraction;
                    Game.Fraction += PreviousFraction;
                    Console.SetCursorPosition(From.Left + 40, From.Top + 10);
                    Console.Write("成功了，进入下一关");
                    System.Threading.Thread.Sleep(2000);
                    ++life;
                    new Game();
                }
            }
        }


        //运行
        private void Run()
        {
            while (!isMortality && !isWin)
            {
                if (!bottom.StartInput() && !isWin)
                {
                    Point p = new Point(bottom.X + bottom.Width / 2, From.Height - 2);
                    ball.Point = p;
                    BallMoveEvent();
                }
            }
        }

        /// <summary>
        /// 统计输赢
        /// </summary>
        public static void StatisticsWinners()
        {
            Fraction = Count * CommonPass.Fraction;
            if (Count >= maxcount && Life >= 1)
                isWin = true;

            if (CommonPass.Detect())
                isWin = true;

            DrawPassInfor();
        }


        /// <summary>
        /// 绘制分数以及关口信息
        /// </summary>
        public static void DrawPassInfor()
        {
            Console.SetCursorPosition(From.Left + 64, From.Top + 10);
            Console.Write("作者：阿杜野兔");
            Console.SetCursorPosition(From.Left + 64, From.Top + 12);
            Console.Write("关口名称：第"+ (pass + 1) +"关");
            Console.SetCursorPosition(From.Left + 64, From.Top + 14);
            Console.Write("您的分数:" + Fraction);
            Console.SetCursorPosition(From.Left + 64, From.Top + 16);
            Console.Write("您的命:" + life);
            Console.SetCursorPosition(From.Left + 64, From.Top + 18);
            Console.Write("最大方块数量:" + maxcount);
            Console.SetCursorPosition(From.Left + 64, From.Top + 20);
            Console.Write("销毁方块数量:" + Count);
        }
        /// <summary>
        /// 判断死亡，死亡了设置属性isMortality
        /// </summary>
        public void IsMortality()
        {
            if (Life <= 0)
                IsMortality1 = true;
        }

        /// <summary>
        /// 小球移动事件
        /// </summary>
        private void BallMoveEvent()
        {
            timer = new Timer();
            timer.Interval = Interval;
            timer.Enabled = true;
            timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
        }

        /// <summary>
        /// 移动小球事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            lock (From.Map)
            {
                if (!Ball.Move())
                {
                    timer.Dispose();
                    bottom.IsRun = false;
                    --Life;
                    IsMortality();
                    return;
                }
            }
        }

        /// <summary>
        /// 开始绘制游戏窗口
        /// </summary>
        public void Start()
        {
            Console.Clear();
            From f = new From();

            ball.Direction.LevelState = 0;
          //  Point p = new Point(5, 6);
          //  ball.Point = p;

            //调整关口
            CommonPass.Start(((PassType)Pass));

            f.DrawBorder();
            f.DrawMap();
        }
    }
}
