﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ganme1
{
    /// <summary>
    /// 关口的公共基类
    /// </summary>
    public class CommonPass
    {
        private int maxcount;//最大方块数量
        private string text; //关口名称
        private static int fraction = 1; //关口分数
        public static int maxpass = 3; //最大关口数量
        private int interval; //速度

        public int Interval
        {
            get { return interval; }
            set 
            {
                interval = value;
                Game.Interval = interval;
            }
        }

        public static int Fraction
        {
            get { return fraction; }
            set
            {
                fraction = value; 
            }
        }

        public string Text
        {
            get { return text; }
            set { text = value; }
        }

        public int Maxcount
        {
            get { return maxcount; }
            set 
            {
                maxcount = value;
                Game.Maxcount = maxcount;
            }
        }

        /// <summary>
        /// 设置关口在地图的表现
        /// </summary>
        public virtual void SetDraw()
        {
            
        }

        public CommonPass()
        {
            
        }

        /// <summary>
        /// 开始设置关口
        /// </summary>
        /// <param name="type"></param>
        public static void Start(PassType type)
        {
            if (type == PassType.Pass1)
            {
                new Pass1().SetDraw();
            }

            if (type == PassType.Pass2)
            {
                new Pass2().SetDraw();
            }

            if (type == PassType.Pass3)
            {
                new Pass3().SetDraw();
            }
        }

        /// <summary>
        /// 检测是否所有方块都已经没了,
        /// </summary>返回TRUE代表所有方块没有了。
        /// <returns></returns>
        public static bool Detect()
        {
            bool state = false;

            int count = 0;
            for (int i = 0; i < From.Height - 1; i++)
            {
                for (int j = 0; j < From.Width; j++)
                {
                    if (From.Map[j, i] == 2)
                    {
                        count++;
                    }
                }
            }

            state = (count == 0);

            return state;
        }
    }
}
